QGIS Application - Bug report #20426
Font will not resize in QGIS Print Layout
2018-11-09 08:59 PM - Andrew Grogan-Kaylor

Status: Closed

Priority: Normal
Assignee:

Category: mac_os_specific

Affected QGIS version:3.4.0
Operating System: Max OS
Pull Request or Patch supplied:
Crashes QGIS or corrupls data:

Regression?: No
Easy fix?: No
Resolution:

Copied to github as #: 28246

Description

I, along with a number of students, are unable to resize the font of map titles in QGIS Print Layout. Can this be fixed? Thank you.

Associated revisions

Revision 930c56f5 - 2018-12-04 03:14 PM - iona5

workaround broken QFontDialog on macOS with Qt5 (Fixes #20426)

QFontDialog using the native dialog is broken in some versions of
Qt5 on macOS, see
- https://bugreports.qt.io/browse/QTBUG-69878
- https://successfulsoftware.net/2018/11/02/qt-is-broken-on-macos-right-now/

this breaks QgsFontButton in ModeQFont. When opening the dialog it will
not change the format after accepting.

normally our code wouldn't use the native dialog on macOS anyway,
but due to using an outdated preprocessor check it was exhibiting
the broken behavior.

this patch restores the usage of a non-native font dialog on macOS.

discussions:

- https://issues.qgis.org/issues/20426
- https://github.com/qgis/QGIS/pull/8585

Revision 4ea8bc52 - 2018-12-04 09:40 PM - iona5

workaround broken QFontDialog on macOS with Qt5 (Fixes #20426)

QFontDialog using the native dialog is broken in some versions of
Qt5 on macOS, see
- https://bugreports.qt.io/browse/QTBUG-69878
- https://successfulsoftware.net/2018/11/02/qt-is-broken-on-macos-right-now/

this breaks QgsFontButton in ModeQFont. When opening the dialog it will

not change the format after accepting.
normally our code wouldn't use the native dialog on macOS anyway,
but due to using an outdated preprocessor check it was exhibiting
the broken behavior.

this patch restores the usage of a non-native font dialog on macOS.

discussions:

- https://issues.qgis.org/issues/20426
- https://github.com/qgis/QGIS/pull/8585

(cherry picked from commit 930c56f5b85db0c452263225fb51f8bf9f2e003c)

History

#1 - 2018-11-09 09:34 PM - Nyall Dawson
- Status changed from Open to Feedback

More info please. Can you post a screencast showing the problem?

#2 - 2018-11-11 06:16 PM - Andrew Grogan-Kaylor
- File QGIS Print Layout Title Issue.png added

Nyall Dawson wrote:

More info please. Can you post a screencast showing the problem?

| don't have screencasting software on the computer I'm using currently, but here is a screenshot of Print Layout with a title. Title can not be resized to
larger font.

#3 - 2018-11-11 07:25 PM - Nyall Dawson

You'll need to find a screencaster here. Currently there's nothing we can do to help with this report.

#4 - 2018-11-11 11:03 PM - Harrissou Santanna

Maybe i'm wrong but if you expect a bigger font by enlarging the label item, you'll fail. Text font and item size are independent. You have to change font in
the label item properties

#5 - 2018-11-20 03:07 PM - Jonas Kiipper
- File QGIS_3.4_fonts.mp4 added

Hi,

i have the same problem (and managed to make a screencast - you can do this also with Quicktime Player).
The problem is basically that changes you make to fonts using "Text Format" dialog are not applied. Only when you use the dropdown menu, you can

change font styles.

see the screencast for details.

Thanks

Jonas

#6 - 2018-11-20 05:38 PM - Andrew Grogan-Kaylor

Thank you for making the screencast. Your screencast shows exactly the same issue that | am having.

Jonas Kupper wrote:

Hi,

i have the same problem (and managed to make a screencast - you can do this also with Quicktime Player).

The problem is basically that changes you make to fonts using "Text Format" dialog are not applied. Only when you use the dropdown menu, you
can change font styles.

see the screencast for details.

Thanks
Jonas

#7 - 2018-11-21 06:19 AM - Nyall Dawson
- Category changed from Map Composer/Printing to mac_os_specific

Is this a Mac OS specific issue? | can't reproduce elsewhere.

#8 - 2018-11-21 03:37 PM - Andrew Grogan-Kaylor

Yes. This may well be only a Mac OS issue. | have seen it on multiple computers, but all were Mac OS.

Nyall Dawson wrote:

Is this a Mac OS specific issue? | can't reproduce elsewhere.

#9 - 2018-11-21 07:45 PM - Nyall Dawson
- Assignee set to Denis Rouzaud

#10 - 2018-11-21 07:46 PM - Nyall Dawson
- Assignee deleted (Denis Rouzaud)

#11 - 2018-12-02 08:24 PM - Jonas Kiipper
hi again,

is the bug probably related to this in src/gui/qgsguiutils.cpp?

QFont getFont( bool &ok, const QFont &initial, const QString &title )
{
// parent is intentionally not set to 'this' as
// that would make it follow the style sheet font
// see also #12233 and #4937
#if defined(Q_OS_MAC) && defined(QT_MAC_USE_COCOA)
/I Native Mac dialog works only for Qt Carbon
return QFontDialog::getFont( &ok, initial, 0, title, QFontDialog::DontUseNativeDialog );
#else
return QFontDialog::getFont( &ok, initial, nullptr, title );
#endif
}

i actually managed to get QGIS compile on my mac (i am really neither a Qt nor a cmake developer) and the build does exhibit the same behavior.

my compiler environment actually evaluates to the #else part of the section which i guess is not intended?

if i apply the following patch i see a more "mac-ish" font dialog and the font is actually applied.

diff --git a/src/gui/qgsguiutils.cpp b/src/gui/ggsguiutils.cpp
index 1799d870a6..32a66d2a85 100644
--- a/src/gui/qgsguiutils.cpp
+++ b/src/gui/qgsguiutils.cpp
@@ -195,12 +195,8 @@ namespace QgsGuiUtils
// parent is intentionally not set to 'this' as
/ that would make it follow the style sheet font
// see also #12233 and #4937
-#if defined(Q_OS_MAC) && defined(QT_MAC_USE_COCOA)
// Native Mac dialog works only for Qt Carbon
return QFontDialog::getFont( &ok, initial, 0, title, QFontDialog::DontUseNativeDialog );
-#else
- return QFontDialog::getFont( &ok, initial, nullptr, title );
-#endif
}

void saveGeometry( QWidget *widget, const QString &keyName )

as i am not familar with the build setup and not sure what the "correct" approach is i am leaving that here but i guess there may be a very easy fix of this
very very annoying problem.

#12 - 2018-12-03 11:32 PM - Nyall Dawson

See discussion at https://github.com/qgis/QGIS/pull/8585 -- the patch was tested but was unsuccessful in fixing the issue. Can you provide feedback
there?
#13 - 2018-12-04 08:32 AM - Jonas Kiipper

i will.

#14 - 2018-12-04 03:14 PM - Anonymous
- % Done changed from 0 to 100
- Status changed from Feedback to Closed

Applied in changeset commit:qgis|930c56f5b85db0c452263225fb518bfof2e003c.

Files
QGIS Print Layout Title Issue.png 388 KB 2018-11-11 Andrew Grogan-Kaylor
QGIS_3.4_fonts.mp4 4.43 MB 2018-11-20 Jonas Kipper
